//20141007 zoearth 這邊是購物車會用到的JS

jQuery(document).ready(function() {
    //20141017 zoearth 綁定修改購物車事件
    z2Cart.cartEditBind();
});

var z2Cart = {};
//20170427 zoearth 新增綁定數量變動按鈕
z2Cart.pageQtyBtn = function(target,max,add){
    var nowVal = parseInt(jQuery(target).val());
    max        = parseInt(max);
    nowVal     = nowVal + add;
    nowVal     = Math.max(1,nowVal);
    nowVal     = Math.min(nowVal,max);
    jQuery(target).val(nowVal);
};

//20141017 zoearth 綁定修改購物車事件
/*
 * cartEditQty    cartKey   修改數量
 * cartEditDel    cartKey   刪除 
 * */
z2Cart.pageReLoadMask = true;//20170324 zoearth 預設開啟reload動畫
//20150708 zoearth 新增物件
z2Cart.nowObj = {};
//20180530 zoearth 刪除購物車按紐
z2Cart.nowDelBtn = null;
//20151210 zoearth 新增額外綁定呼叫陣列
z2Cart.cartEditAddBind = [];

//20170718 zoearth 新增訊息物件紀錄錯誤
z2Cart.getMsg = {};

//收藏功能
z2Cart.likeToggleStartEvent = {};
z2Cart.likeToggleEndEvent   = {};
z2Cart.keyName = '';
var goUrl = '';
z2Cart.cartEditBind = function(){
    
    //20141022 zoearth 計算z2CartReNewBlock 區塊數量
    //if (!(jQuery("[class*=z2CartReNewBlock]").length > 0 ))//20170324 zoearth 取消該判斷
    //{
    //    //console.log('error z2_cart 033');
    //    return false;
    //}

    //20141103 zoearth 基本網址為
    var getParams = location.href.match(/([^&?]*)=([^&]*)/gi);
    var addGet    = '';
    if (getParams)
    {
        addGet    = getParams.join('&');
    }
    goUrl = baseUrl+'index.php?option=com_z2_cart&view=cart&task=edit&'+addGet;
    
    //修改數量
    jQuery(".cartEditQty").unbind('change').bind('change',function(){
        z2Cart.nowObj = jQuery(this);//放入物件
        var cartKey = jQuery(this).attr('cartKey');
        var qty = jQuery(this).val();
        if (cartKey && qty > 0 )
        {
            goUrl += '&action=qty';
            goUrl += '&cartKey='+cartKey;
            goUrl += '&qty='+qty;
            
            //20141023 zoearth 重新讀取區塊更新資料
            z2Cart.renewBlock(goUrl);
        }
        else
        {
            console.log('error z2_cart 034');
            jQuery(this).val(1);
        }
    });
    //刪除
    jQuery(".cartEditDel").unbind('click').bind('click',function(){
        z2Cart.nowObj = jQuery(this);//放入物件
        z2Cart.nowDelBtn = null;
        z2Cart.nowDelBtn = jQuery(this);//放入刪除的BTN(配合GTM)
        
        var cartKey = jQuery(this).attr('cartKey');
        
        //20180530 zoearth 新增GTM事件
        if (typeof z2Cart.onGTMremoveFromCart == 'function')
        {
            var postData = {
                    'action':'del',
                    'cartKey':cartKey,
            };
            z2Cart.onGTMremoveFromCart(postData);
        }
        
        if (cartKey)
        {
            goUrl += '&action=del';
            goUrl += '&cartKey='+cartKey;
            
            //20141023 zoearth 重新讀取區塊更新資料
            z2Cart.renewBlock(goUrl);
        }
        else
        {
            console.log('error z2_cart 046');
        }
    });
    //修改運送方式
    jQuery(".cartEditShipping").unbind('change').bind('change',function(){
        z2Cart.nowObj = jQuery(this);//放入物件
        var itemId = jQuery(this).val();
        if (!itemId)
        {
            itemId = 0;
        }
        goUrl += '&action=EditShipping';
        goUrl += '&itemId='+itemId;
        
        //20141023 zoearth 重新讀取區塊更新資料
        z2Cart.renewBlock(goUrl);
    });
    
    //修改付款方式
    jQuery(".cartEditPayment").unbind('change').bind('change',function(){
        z2Cart.nowObj = jQuery(this);//放入物件
        var itemId = jQuery(this).val();
        if (!itemId)
        {
            itemId = 0;
        }
        goUrl += '&action=EditPayment';
        goUrl += '&itemId='+itemId;
        
        //20141023 zoearth 重新讀取區塊更新資料
        z2Cart.renewBlock(goUrl);
    });
    
    //20160325 zoearth 修改運送與付款方式
    jQuery(".cartEditGo").unbind('change').bind('change',function(){
        z2Cart.nowObj = jQuery(this);//放入物件
        
        var paymentId  = jQuery(this).data('paymentid');
        var shippingid = jQuery(this).data('shippingid');
        if (!(paymentId >= 0 || shippingid >= 0 ))
        {
            alert('ERROR 0113 Need data-paymentid or data-shippingid');
            return false;
        }
        
        goUrl += '&action=EditCart';
        if (paymentId > 0 )
        {
            goUrl += '&paymentId='+paymentId;
        }
        if (shippingid > 0 )
        {
            goUrl += '&shippingId='+shippingid;
        }
        
        //20141023 zoearth 重新讀取區塊更新資料
        z2Cart.renewBlock(goUrl);
    });
    
    //20151210 zoearth 呼叫額外綁定事件(外掛擴充)
    if (z2Cart.cartEditAddBind.length > 0 )
    {
        for (var p=0;p<z2Cart.cartEditAddBind.length;p++)
        {
            if (typeof z2Cart.cartEditAddBind[p] == 'function')
            {
                z2Cart.cartEditAddBind[p]();
            }
        }
    }
};

//20141023 zoearth 
z2Cart.renewBlock = function(goUrl){
    
    //20141022 zoearth 取得loading 頁面
    if (z2Cart.pageReLoadMask)
    {
        var loadingHtml = '<img src="'+baseUrl+'media/z2_cart/ajax-loader.gif" >';
        if (jQuery(".loadingHtml").length > 0)
        {
            loadingHtml = jQuery(".loadingHtml").html();
        }
        
        //20151007 zoearth 如果函式存在
        if (typeof jQuery("body").mask == 'function' )
        {
            jQuery("body").mask(loadingHtml);
        }
    }
    jQuery.get(goUrl, function(data) {
        //20150828 zoearth 新增判斷如果兩邊DIV數量不合則重新整理
        if (jQuery("[class*=z2CartReNewBlock]").length != jQuery(data).find("[class*=z2CartReNewBlock]").length)
        {
            location.reload();
        }
        else
        {
            jQuery(data).find("[class*=z2CartReNewBlock]").each(function(){
                var className = jQuery(this).attr('class').match(/(z2CartReNewBlock[0-9]*)/)[0];
                //alert(className);
                jQuery("."+className).html(jQuery(this).html());
            });
            z2Cart.cartEditBind();
            jQuery("#z2CartForm").validate();

            if (z2Cart.pageReLoadMask)
            {
                //20151007 zoearth 如果函式存在
                if (typeof jQuery("body").unmask == 'function' )
                {
                    jQuery("body").unmask();
                }
            }
            //20170531 zoearth 新增 afterRenewBlock
            if (typeof z2Cart.afterRenewBlock == 'function' )
            {
                z2Cart.afterRenewBlock(data);
            }
        }
    });
};

//20141007 zoearth 是否送出中
z2Cart.sending = false;

//20160715 zoearth 共用數量綁定
z2Cart.bindCartQty = function(maxnum,target,bind){
    if (typeof target != 'object' )
    {
        var target = jQuery(target);
        if (typeof target != 'object' )
        {
            alert('ERROR 0196 Cant Find Options target Object ');
            return false;
        }
    }
    
    //取得目前值
    var nowVal = Math.max(1,Math.min(jQuery(target).val(),maxnum));
    
    //如果是select
    if (jQuery(target).is('select'))
    {
        jQuery(target).html("");
        for (var i=1;i<=maxnum;i++)
        {
            jQuery(target).append('<option value="'+i+'" >'+i+'</option>');
        }
    }

    //綁定更新數量事件
    if (!bind)
    {
        bind = target;
    }
    jQuery(bind).unbind('mouseup change').bind('mouseup change',function(){
        if (jQuery(target).val() > maxnum)
        {
            jQuery(target).val(maxnum);
        }
    });
    //設定數值
    jQuery(target).val(nowVal);
}

//通用規格綁定
z2Cart.bindCartOp = function(tObj){
    //是select
    if (jQuery(tObj).find(':selected'))
    {
        //規格的庫存
        var qty    = jQuery(tObj).find(':selected').data('qty');
    }
    else
    {
        var qty    = jQuery(tObj).data('qty');
    }
    
    var target = jQuery(tObj).data('target');
    var bind   = jQuery(tObj).data('bind');

    if (qty && qty > 0 && target && jQuery(target))
    {
        //綁定數量事件
        z2Cart.bindCartQty(qty,target,bind);
    }
    else
    {
        alert('z2CartOp need data-maxnum data-target ');
    }
}

//移動到新函式
z2Cart.SendToCart = function(sBtn){
    z2Cart.nowObj = jQuery(sBtn);//放入物件
    //20171013 zoearth 新增起始檢查事件
    if (typeof z2Cart.onBeforeStartCheck == 'function')
    {
        var check = z2Cart.onBeforeStartCheck();
        if (typeof check == 'string' && check != '')
        {
            z2Cart.getMsg.error = 1;
            //20150603 zoearth 新增事件
            if (typeof z2Cart.onMessage == 'function')
            {
                z2Cart.onMessage(check);
            }
            else
            {
                z2Cart.showZ2CartAlertModal(check);
            }
            return false;
        }
    }
    
    //20150323 zoearth 全面改用綁訂方式
    //檢查參數 itemId
    var itemId = jQuery(sBtn).data('itemId') ? jQuery(sBtn).data('itemId'):jQuery(sBtn).attr('itemId');
    var param  = jQuery(sBtn).data('param') ? jQuery(sBtn).data('param'):jQuery(sBtn).attr('param');//20180329 zoearth 新增參數特殊處理
    if (!(itemId > 0 ))
    {
        alert('error itemId 0142');return false;
    }
    
    //20150728 zoearth 如果有prefix
    var prefix = jQuery(sBtn).data('prefix') ? jQuery(sBtn).data('prefix'):jQuery(sBtn).attr('prefix');
    if (!prefix)
    {
        prefix = '';
    }
    //檢查參數  qty
    var qty = jQuery(".z2Cart_"+itemId+"_qty"+prefix).val();
    if (!(qty > 0 ))
    {
        //20151020 zoearth 取消該錯誤
        qty = 1;
        //alert('error z2Cart_'+itemId+'_qty 0148');return false;
    }
    
    var option = {};
    //其他參數
    jQuery(".z2Cart_"+itemId+"_option"+prefix).each(function(key, value) { 
        var name     = jQuery(this).attr('name');
        option[name] = jQuery(this).val();
    });
    
    var postVal = {
            "itemId"    : itemId,
            "qty"       : qty,
            "proOption" : option,
            "param"     : param ? param:null,
    };
    
    //20151007 zoearth 新增優惠參數saleHash
    var saleHash = jQuery(sBtn).attr('saleHash');
    if (saleHash)
    {
        postVal.saleHash = saleHash;
    }
    
    //20160719 zoearth 新增附加送出功能
    if (jQuery(".z2Cart_"+itemId+"_addBuy").length > 0 )
    {
        var addBuy = [];
        jQuery(".z2Cart_"+itemId+"_addBuy:checked").each(function(){
            
            var addItemid = jQuery(this).attr('itemId') ? jQuery(this).attr('itemId'):jQuery(this).data('itemid');
            if (!(addItemid > 0 ))
            {
                alert('ERROR 0333 Need Add Buy addItemid');
                return false;
            }
            var addQty = jQuery(".z2Cart_"+addItemid+"_qty").val();
            if (!(addQty > 0 ))
            {
                alert('ERROR 0339 Need Add Buy qty');
                return false;
            }
            //優惠HASH
            var addSaleHash = jQuery(this).attr('saleHash') ? jQuery(this).attr('saleHash'):jQuery(this).data('salehash');
            
            //其他參數
            var addOption = {};
            jQuery(".z2Cart_"+addItemid+"_option").each(function(key, value) {
                var name = jQuery(this).attr('name');
                addOption[name] = jQuery(this).val();
            });
            addBuy.push({
                    "itemId"    : addItemid,
                    "qty"       : addQty,
                    "proOption" : addOption,
                    "saleHash"  : addSaleHash,
            });
        });
        
        //新增附加購買
        postVal.addBuy = addBuy;
    }
    
    //20141007 zoearth 送出表單
    //var postVal = jQuery("form.z2CartFormItem"+itemId).serialize();
    var url = baseUrl+'index.php?option=com_z2_cart&view=cart&task=add';
    z2Cart.sending = true;
    
    //20150603 zoearth 新增事件
    if (typeof z2Cart.onBeforePostCart == 'function')
    {
        z2Cart.onBeforePostCart();
    }

    //20171017 zoearth 新增外掛呼叫
    postVal.plg = [];
    jQuery(".z2Cart_"+itemId+"_plg"+prefix).each(function() { 
        if (jQuery(sBtn).prop('type') == 'checkbox' || jQuery(sBtn).prop('type') == 'radio' )
        {
            var isCheck = jQuery(sBtn).prop('checked');
            if (isCheck == true)
            {
                postVal.plg.push(jQuery(sBtn).val());
            }
        }
        else if (jQuery(sBtn).val() != '')
        {
            postVal.plg.push(jQuery(sBtn).val());
        }
    });
    
    //20180530 zoearth 新增GTM事件
    if (typeof z2Cart.onGTMaddToCart == 'function')
    {
        z2Cart.onGTMaddToCart(postVal);
    }
    
    jQuery.post(url, postVal,function(data){
        if (data.message)
        {
            z2Cart.getMsg = data;
            //20150603 zoearth 新增事件
            if (typeof z2Cart.onAfterPostCart == 'function')
            {
                z2Cart.onAfterPostCart();
            }
            
            //20150603 zoearth 新增事件
            if (typeof z2Cart.onMessage == 'function')
            {
                z2Cart.onMessage(data.message);
            }
            else
            {
                z2Cart.showZ2CartAlertModal(data.message);
            }
            
            z2Cart.reloadCart(z2Cart.keyName);//重新整理購物車
        }
        else
        {
            console.log(' data.message error 0175!');
        }
        z2Cart.sending = false;
    }, "json").error(function() { console.log('send error 0178!');z2Cart.sending = false; });
    
}

//20141007 zoearth 綁定送出按鈕
z2Cart.bindBuyBtn = function(keyName){
    
    //還需要新增 X 多少的功能
    //20160715 zoearth 整合數量選擇功能
    //選擇規格自動變動最大數量
    jQuery(".z2CartOp").unbind('change').bind('change',function(){
        z2Cart.bindCartOp(jQuery(this));
    });
    jQuery(".z2CartOp").each(function(){
        z2Cart.bindCartOp(jQuery(this));
    });
    
    //20160718 zoearth 綁定 z2CartQty 
    jQuery(".z2CartQty").each(function(){
        var num    = jQuery(this).data('num');
        var bind   = jQuery(this).data('bind');
        if (num > 0 )
        {
            z2Cart.bindCartQty(num,jQuery(this),bind);
        }
    });
    
    keyName = keyName ? keyName:z2Cart.keyName;
    if (keyName)
    {
        jQuery("[class*="+keyName+"]").unbind('click').bind('click',function(){
            //移動到新函式
            z2Cart.keyName = keyName;
            z2Cart.SendToCart(this);
        });
    }
    //這邊綁定收藏功能
    jQuery(".likeToggleBtn").unbind('click').bind('click',function(){
        sendLikeToggle(this);
    });
};

//這邊是收藏功能
function sendLikeToggle(tBtn)
{
    var nBtn  = jQuery(tBtn);
    var pid   = jQuery(tBtn).data('pid');
    var liked = jQuery(tBtn).data('liked');
    if (!(pid > 0 ))
    {
        alert('ERROR need data-pid');return false;
    }
    
    //增加收藏
    if (liked != "1")
    {
        url = baseUrl+'index.php?option=com_z2_cart&view=like&task=add';
    }
    else
    {
        url = baseUrl+'index.php?option=com_z2_cart&view=like&task=remove';
    }
    
    if (typeof z2Cart.likeToggleStartEvent == 'function')
    {
        z2Cart.likeToggleStartEvent(nBtn,liked);
    }
    
    jQuery.post(url, { "pid": pid },function(data){
        if (data.result == 1)
        {
            jQuery(nBtn).data('liked',(liked == "1" ? 0:1));
        }
        else
        {
            alert(data.msg);
        }
        
        if (typeof z2Cart.likeToggleEndEvent == 'function')
        {
            z2Cart.likeToggleEndEvent(nBtn,liked,data);
        }
    }, "json").error(function() { alert("error 8178 z2cartjs");}); 
}

//20141007 zoearth 提醒視窗
z2Cart.showZ2CartAlertModal = function(outputHtml){
    //若沒有 則新增
    if (!(jQuery("#z2CartAlertModal").length > 0 ))
    {
        var html = '<div id="z2CartAlertModal" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true"></div>';
        jQuery("body").append(html);
        jQuery('#z2CartAlertModal').modal({
            keyboard: false
        });
    }
    jQuery("#z2CartAlertModal").html(outputHtml);
    jQuery('#z2CartAlertModal').modal('show');
};

//20150323 zoearth 刪除購物車項目
z2Cart.delCartItem = function(key,param,delBtn){
    if (key)
    {
        z2Cart.nowDelBtn = null;
        if (delBtn)
        {
            z2Cart.nowDelBtn = delBtn;//放入刪除的BTN(配合GTM)
        }
        
        postData = {
            'action':'del',
            'cartKey':key,
            'param'  :param ? param:null,
        };
        var url = baseUrl+'index.php?option=com_z2_cart&view=cart&task=del';
        
        //20150603 zoearth 新增事件
        if (typeof z2Cart.onBeforePostCart == 'function')
        {
            z2Cart.onBeforePostCart();
        }
        
        //20180530 zoearth 新增GTM事件
        if (typeof z2Cart.onGTMremoveFromCart == 'function')
        {
            z2Cart.onGTMremoveFromCart(postData);
        }
        
        jQuery.post(url,postData,function(data){
            if (data.message)
            {
                z2Cart.getMsg = data;
                //20150603 zoearth 新增事件
                if (typeof z2Cart.onAfterPostCart == 'function')
                {
                    z2Cart.onAfterPostCart();
                }
                
                //20150603 zoearth 新增事件
                if (typeof z2Cart.onDelMessage == 'function')
                {
                    z2Cart.onDelMessage(data.message);
                }
                else
                {
                    z2Cart.showZ2CartAlertModal(data.message);
                }
                
                z2Cart.reloadCart(z2Cart.keyName);//重新整理購物車
            }
            else
            {
                console.log(' data.message error 0204!');
            }
        },'json').error(function() { console.log('send error 0206!');z2Cart.sending = false; });
    }
};

//20150323 zoearth 重新整理購物車
z2Cart.reloadCart = function(keyName){
    //重新讀取目前頁面的資料 z2CartReloadDiv
    if (jQuery(".z2CartReloadDiv").length > 0 )
    {
        jQuery.get(location.href,{},function(data){
            jQuery(data).find(".z2CartReloadDiv").each(function(key,value){
                jQuery(".z2CartReloadDiv").eq(key).html(jQuery(this).html());
            });
            
            //20150603 zoearth 新增事件
            if (typeof z2Cart.onAfterReloadCart == 'function')
            {
                z2Cart.onAfterReloadCart();
            }
            z2Cart.bindBuyBtn(keyName ? keyName:z2Cart.keyName);
        });
    }
};